#===========================================================================#
# class baseClass: initialization, accessors, methods
#===========================================================================#


#---------------------------------------------------------------------------#
# baseClass initialization:
#---------------------------------------------------------------------------#

"init.baseClass" <-
function(.Object, mydir=as.character(getwd()), ...) {
print("---initialize:baseClass---")
print(paste("base:init:mydir = ", mydir))
   if (mydir == "") {
      mydir <- as.character(getwd());
   }#if
   if (substr(mydir, nchar(mydir), nchar(mydir)) == "/") {
      mydir <- substr(mydir, 0, nchar(mydir)-1);
   }#if
print(paste("base:init:mydir = ", mydir))
 .Object <- callNextMethod(.Object, mydir=mydir, ...);
 .Object;
}#init.baseClass

setMethod("initialize", "baseClass", init.baseClass)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setValidity("baseClass",
   function(object) {
print("---setValidity:baseClass---")
      msg <- NULL;
      strg <- object@myname;
      if (!(is(strg, "character") && nchar(strg) > 0)) {
         msg <- validMsg(msg, paste(sQuote("myname"), "is missing"));
      }#if
print(paste("base:valid:myname = ",object@myname))
      strg <- object@mydir;
      if (!(is(strg, "character") && file.exists(strg))) {
         msg <- validMsg(msg, paste(sQuote("mydir"), "is not a system directory"));
      }#if
print(paste("base:valid:mydir = ",object@mydir))
      if (is.null(msg)) TRUE else msg;
   }
)#setValidity


#---------------------------------------------------------------------------#
# baseClass accessors:
#---------------------------------------------------------------------------#

setGeneric("myname", function(object) standardGeneric("myname"))
setMethod("myname", signature(object="baseClass"),
   function(object) object@myname
)#myname

setGeneric("myname<-", function(object, value) standardGeneric("myname<-"))
setReplaceMethod("myname", signature(object="baseClass", value="character"),
   function(object, value) {
      object@myname <- value;
      object;
   }
)#myname<-


#---------------------------------------------------------------------------#
# baseClass methods:
#---------------------------------------------------------------------------#

setGeneric("export.base", function(object,...) standardGeneric("export.base"))

"export.baseClass" <-
function(object, ...) {
print("------export.baseClass------")
print(paste("baseClass:export:myname = ",object@myname))

}#export.baseClass

setMethod("export.base", "baseClass", export.baseClass);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
