#===========================================================================#
# class derivedClass: initialization, accessors, methods
#===========================================================================#


#---------------------------------------------------------------------------#
# derivedClass initialization:
#---------------------------------------------------------------------------#

"init.derivedClass" <-
function(.Object, mytitle="MyTitle", ...) {
print("---initialize:derivedClass---")
   if (mytitle == "") {
      mytitle = "MyTitle";
   }#if
  .Object <- callNextMethod(.Object, mytitle=mytitle, ...);
print(paste("derived:init:mytitle = ",.Object@mytitle))
print(paste("derived:init:mydir = ", .Object@mydir))
print(paste("derived:init:myname = ", .Object@myname))
  .Object;
}#init.derivedClass

setMethod("initialize", "derivedClass", init.derivedClass)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setValidity("derivedClass",
   function(object) {
print("---setValidity:derivedClass---")
      msg <- NULL;
      strg <- object@mytitle;
      if (!(is(strg, "character") && nchar(strg) > 0)) {
         msg <- validMsg(msg, paste(sQuote("mytitle"), "is missing"));
      }#if
print(paste("derived:valid:mytitle = ",object@mytitle))
      if (is.null(msg)) TRUE else msg;
   }
)#setValidity


#---------------------------------------------------------------------------#
# derivedClass accessors:
#---------------------------------------------------------------------------#

setGeneric("mytitle", function(object) standardGeneric("mytitle"))
setMethod("mytitle", signature(object="derivedClass"),
   function(object) object@mytitle
)#mytitle

setGeneric("mytitle<-", function(object, value) standardGeneric("mytitle<-"))
setReplaceMethod("mytitle", signature(object="derivedClass", value="character"),
   function(object, value) {
      object@mytitle <- value;
      object;
   }
)#mytitle<-


#---------------------------------------------------------------------------#
# derivedClass methods:
#---------------------------------------------------------------------------#

setGeneric("export.derived", function(object,...) standardGeneric("export.derived"))

"export.derivedClass" <-
function(object, myname=character(0), mydir=as.character(getwd()), mytitle=character(0)) {
print("------export.derivedClass------")
   txt <- myname(object);
print(paste("derivedClass:export:myname = ",txt))
print(paste("derivedClass:export:myname = ",myname))
print(paste("derivedClass:export:mytitle = ",mytitle))

#   object <- callNextMethod(object);
#   object <- callNextMethod();
print(paste("derivedClass:export:mytitle = ",mytitle))

}#export.derivedClass

setMethod("export.derived", "derivedClass", export.derivedClass);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
